using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RhinoMockDemo.DBOs;
using RhinoMockDemo.Providers;

namespace RhinoMockDemo
{
	public partial class CustomersForm : Form, ICustomerView
	{
		private CustomerPresenter _presenter;
		private IClassFactory _factory;

		public CustomersForm(IClassFactory factory)
		{
			InitializeComponent();
			_factory = factory;
			// initialize the presenter
			_presenter = factory.CustomerPresenter(this);
			_presenter.Initialize();
		}

		public List<ICustomer> Customers
		{
			set
			{
				//bindingSource1.DataSource = value;
				dataGridView1.DataSource = value;
			}
		}

		private void bindingSource1_DataMemberChanged(object sender, EventArgs e)
		{

		}

		private void bindingSource1_ListChanged(object sender, ListChangedEventArgs e)
		{
		}

		private void dataGridView1_UserDeletedRow(object sender, DataGridViewRowEventArgs e)
		{
			DataGridViewCell oCell = e.Row.Cells[4];
			int iID = (int)oCell.Value;
			_presenter.DeleteCustomer(iID);
		}
	}
}