/*
 * Created by: 
 * Created: Tuesday, May 15, 2007
 */
using System;
using System.Collections.Generic;
using RhinoMockDemo.DBOs;

namespace RhinoMockDemo.Providers
{
	public class CustomerPresenter
	{
		private ICustomerView _view;
		private IClassFactory _factory;
		private ICustomerDbo _dbo;
		
		public CustomerPresenter(ICustomerView view, IClassFactory factory): this(view, factory, factory.CustomerDbo)
		{
		}
		
		public CustomerPresenter(ICustomerView view, IClassFactory factory, ICustomerDbo dbo)
		{
			_view = view;
			_factory = factory;
			_dbo = dbo;
		}
		
		public void Initialize()
		{
			List<ICustomer> oList = _dbo.GetAllCustomers();
			_view.Customers = oList;
		}

		public void DeleteCustomer(int customerId)
		{
			_dbo.DeleteCustomer(customerId);
		}
		
		public ICustomer CreateCustomer()
		{
			return _dbo.CreateCustomer();
		}
		
		public string FullName(ICustomer c)
		{
			string sFullName = c.Title;
			if (sFullName.Length > 0) 
				sFullName += " " + c.FirstName + " " + c.LastName;
			else 
				sFullName = c.FirstName + " " + c.LastName;
			return sFullName;
		}
		
		public void HandlesEvent()
		{
			_dbo.MyEvent += new EventHandler<EventArgs>(_dbo_MyEvent);
		}

		void _dbo_MyEvent(object sender, EventArgs e)
		{
			Initialize();
		}
	}
}